package com.imanan.LiveCamera;

//import java.io.*;  
import java.io.File;
import java.io.FileOutputStream;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.impl.client.DefaultHttpClient;

import android.content.ContentResolver;
import android.content.ContentValues;
import android.content.Context;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.hardware.Camera;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.provider.MediaStore;
import android.provider.MediaStore.Images;
//import android.view.KeyEvent;
//import android.view.MotionEvent;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.widget.Toast;

public class CameraPreview extends SurfaceView
    implements SurfaceHolder.Callback {
 
    private SurfaceHolder mHolder;          // T[tF[Xz_[
    private Context mContext;               // ReNXg
    private Camera mCamera;                 // J
    private Camera.Parameters mCamparam;    // Jݒ
    private boolean mProgress = false;              // BestO
    private boolean mHasSurface;            // T[tF[X̑݃tO
    private boolean mCameraPreviewing;      // vr[stO
    private Bitmap mBitmap;                 // Beꂽrbg}bv
    public int pwidth;
    public int pheight;
 
    /**
     * RXgN^
     * @param context
     */
    public CameraPreview(Context context) {
        super(context);
      	Log.d("CameraPreview","start");
        mContext = context;
        mHolder = getHolder();
        initSurface();
 
    }
    /**
     * T[tF[X쐬̃R[obN
     */
    public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
      	Log.d("surfaceChanged","start");
        mCamparam = mCamera.getParameters();
//      mCamparam.setPreviewSize((int)(width*0.5), (int)(height*0.5));
        mCamparam.setPreviewSize(width, height);
        mCamera.setParameters(mCamparam);
        startCameraPreview();
 
    }
    /**
     * ʂ̍쐬R[obbN
     */
    public void surfaceCreated(SurfaceHolder holder) {
      	Log.d("surfaceCreated","start");
        mCamera = Camera.open();
        mCamparam = mCamera.getParameters();
        try {
            mCamera.setPreviewDisplay(holder);
        } catch(Exception e) {
            mCamera.release();
            mCamera = null;
        }
        mHasSurface = true;
        
    }
    /**
     * ʂ̔jR[obN
     */
    public void surfaceDestroyed(SurfaceHolder holder) {
      	Log.d("surfaceDestroyed","start");
        cameraDestroy();
        mHasSurface = false;
    }
    /**
     * ĊJ
     */
    public void onResume() {
      	Log.d("onResume","start");
        if (mHasSurface) {
            surfaceCreated(mHolder);
            startCameraPreview();
        } else {
            initSurface();
        }
    }
    /**
     * ꎞ~
     */
    public void onPuse() {
      	Log.d("onPuse","start");
        cameraDestroy();
    }
    
    /**
     * T[tF[X̏
     */
    private void initSurface() {
        mHolder.addCallback(this);
        mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }
 
    /**
     * vr[̊Jn
     */
    private void startCameraPreview() {
      	Log.d("startCameraPreview","start");
        if (!mCameraPreviewing) {
            mCamera.startPreview();
            mCameraPreviewing = true;
        }
    }
    /**
     * vr[̒~
     */
    private void stopCameraPreview() {
      	Log.d("stopCameraPreview","start");
        if (mCameraPreviewing) {
            mCamera.stopPreview();
            mCameraPreviewing = false;
        }
    }
 
    /**
     * J̊J
     */
    private void cameraDestroy() {
      	Log.d("cameraDestroy","start");
        if (mCamera != null) {
            stopCameraPreview();
            mCamera.release();
            mCamera = null;
        }
    }
    
    /**
     * BeR}h
     */
    public void takePicture() {
      	Log.d("takePicture","start");
//      if (!mProgress) {
        if (mProgress != true) {
            mProgress = true;
            mCamera.setPreviewCallback(savePreviewImage); // Ńvr[R[obNZbg
        }
      	Log.d("takePicture","end");
    }
 
    /**
     * vr[R[obN
     *   prepareSavePreviewImageR[obNœo^Avr[摜擾
     */
    private final Camera.PreviewCallback savePreviewImage =
        new Camera.PreviewCallback() {        
            public void onPreviewFrame(byte[] data, Camera camera) {
              	Log.d("onPreviewFrame","start");
            	mCamera.setPreviewCallback(null);  // łɃvr[R[obN
                stopCameraPreview();
                mProgress = true;             
                saveImage(data);  // 摜̕ۑ
                startCameraPreview();
              	Log.d("onPreviewFrame","end");
            }
        };
 
    /**
     * J̃vr[f[^ۑ
     *
     */
    private boolean saveImage(byte[] data) {
    	Log.d("saveImage","start");
    	
        if (data == null) {
            return false;
        }

//      final int width = getWidth();
//      final int height = getHeight();
        final int width = mCamera.getParameters().getPreviewSize().width;
        final int height = mCamera.getParameters().getPreviewSize().height;

        // ϊ̃sNZz
        int[] rgb = new int[(width * height)];
        try {
            mBitmap = Bitmap.createBitmap(width, height, Bitmap.Config.ARGB_8888);
            // YUV420Bitmapɕϊ
            decodeYUV420SP(rgb, data, width, height);
            mBitmap.setPixels(rgb, 0, width, 0, 0, width, height);
        } catch (Exception e) {
        	Toast.makeText(mContext, "ϊG[", Toast.LENGTH_SHORT).show(); 
            return false;
        }
        // 擾łBitmapCX^Xt@CɕۑƂ뗪
        doSave(mBitmap);
        mProgress = false;

        Log.d("saveImage","end");
        return true;
    }

    /**
     * YUV420f[^Bitmapɕϊ
     * @param rgb
     * @param yuv420sp
     * @param width
     * @param height
     */
    // YUV420 to BMP
//    public static final void decodeYUV420SP(int[] rgb, byte[] yuv420sp, int width, int height) {
  public final void decodeYUV420SP(int[] rgb, byte[] yuv420sp, int width, int height) {
      final int frameSize = width * height;
 
      // {JVݒÄm
      SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(mContext);
      int bo = Integer.parseInt(pref.getString("infoBokashi","0"));
      int k = 0;
      int[] bo_r = new int[width];
      int[] bo_g = new int[width];
      int[] bo_b = new int[width];

  	Log.d("decodeYUV420SP","start");
  	
        for (int j = 0, yp = 0; j < height; j++) {
            int uvp = frameSize + (j >> 1) * width, u = 0, v = 0;
            for (int i = 0; i < width; i++, yp++) {
                int y = (0xff & ((int) yuv420sp[yp])) - 16;
                if (y < 0) y = 0;
                if ((i & 1) == 0) {
                        v = (0xff & yuv420sp[uvp++]) - 128;
                        u = (0xff & yuv420sp[uvp++]) - 128;
                }
 
                int y1192 = 1192 * y;
                int r = (y1192 + 1634 * v);
                int g = (y1192 - 833 * v - 400 * u);
                int b = (y1192 + 2066 * u);
 
                if (r < 0) r = 0; else if (r > 262143) r = 262143;
                if (g < 0) g = 0; else if (g > 262143) g = 262143;
                if (b < 0) b = 0; else if (b > 262143) b = 262143;

                // {JV@\(lۊ)
                if ( bo > 0 ) {
	              k=i/bo;
                  if (j % bo == 0 ) {
	                if ( i % bo == 0 ) {
 	                  bo_r[k] = r;
                      bo_g[k] = g;
                      bo_b[k] = b;
//                    Log.d("decodeYUV420SP","i:"+i+" j:"+j+" k:"+k);
	                }
                  }
                }
                
                if ( bo > 0 && bo_r[k] >= 0 && bo_g[k] >= 0 && bo_b[k] >= 0 ) {
                  // {JV@\(o)
                  rgb[yp] = 0xff000000 | ((bo_r[k] << 6) & 0xff0000) | ((bo_g[k] >> 2) & 0xff00) | ((bo_b[k] >> 10) & 0xff);
                } else {
                  // m[}@\(o)
                  rgb[yp] = 0xff000000 | ((r << 6) & 0xff0000) | ((g >> 2) & 0xff00) | ((b >> 10) & 0xff);
                }
            }    
        }
      	Log.d("decodeYUV420SP","end");
    }
 
    public void doSave(Bitmap bitmap) {
        
        Log.d("doSave","start");

        FileOutputStream foStream = null;  

        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(mContext);
        String infoUserid = pref.getString("infoUserid", "");
        String[] infoUseridValArr = infoUserid.split("@");  // userid.serverid
        Log.d("doSave","userid:"+infoUseridValArr[0]);
        Log.d("doSave","serverid:"+infoUseridValArr[1]);
        
        String imgName = Environment.getExternalStorageDirectory() + "/LiveCamera/" + System.currentTimeMillis() +".jpg";  
        pref.edit().putString("infoPhoto", imgName).commit();
        File file = new File(imgName);
        file.getParentFile().mkdir();
    	    	
        //tH_̃pX\܂BB  
//        File file = new File(Environment.getExternalStorageDirectory().getPath() + "/LiveCamera/");  
        //tH_݂ȂꍇɃtH_쐬܂B  

/*        
        if(!file.exists()){  
          try {  
            file.mkdir();  
          }catch(Exception e){  
            Toast.makeText(mContext, "fBNg쐬ŃG[܂B", Toast.LENGTH_SHORT).show();  
            e.printStackTrace();  
          }
        }  
        //ő̂ƂԂȂO̐ݒ肪ł܂B  
        String imgName = Environment.getExternalStorageDirectory().getPath() + "/LiveCamera/" + System.currentTimeMillis() +".jpg";  
*/

        try {  
          foStream = new FileOutputStream(imgName);  
          bitmap.compress(Bitmap.CompressFormat.JPEG, 100, foStream);
          foStream.close();  

          try {  
            //M[o^
            ContentValues values = new ContentValues();  
            ContentResolver contentResolver = mContext.getContentResolver();  
            values.put(Images.Media.MIME_TYPE, "image/jpeg");  
            values.put("_data", imgName);
            contentResolver.insert(MediaStore.Images.Media.EXTERNAL_CONTENT_URI, values);  
          }catch(Exception e){  
            Toast.makeText(mContext, "ċNɉ摜F܂B", Toast.LENGTH_SHORT).show();  
            e.printStackTrace();  
          }  

          //摜f[^̃Abv
          String fileUp = doPost("http://"+infoUseridValArr[1]+".imanan.com/upload.php?userno="+infoUseridValArr[0],new File(imgName),System.currentTimeMillis() +".jpg" );
          Toast.makeText(mContext, fileUp, Toast.LENGTH_SHORT).show();  

        } catch (Exception e) {  
          Toast.makeText(mContext, "t@C̕ۑɃG[܂B", Toast.LENGTH_SHORT).show();  
          e.printStackTrace();  
        }  
        Log.d("doSave","end");
      }

    public String doPost( String url, File params, String filename )
    {
      Log.d("doPost","start url:"+url);

      try {            
        DefaultHttpClient client = new DefaultHttpClient();
        //@͐œKPHPŏĂ
        HttpPost post = new HttpPost(url);
        MultipartEntity entity = new MultipartEntity();
        post.setEntity(entity);
        //肽t@C̃Zbg
        FileBody fileBody = new FileBody(params);
        entity.addPart("upfile", fileBody);

        Log.d("doPost","exec");

        //M
        HttpResponse response = client.execute( post );
        Log.d("doPost","response");
        int status = response.getStatusLine().getStatusCode();
        if ( status != HttpStatus.SC_OK )
          throw new Exception( "" );
//      return EntityUtils.toString( response.getEntity(), "UTF-8" );
        Log.d("doPost","end");
        return "摜Abv܂B";
      }
      catch ( Exception e ) {
        return null;
      }
    }
}