package com.imanan.LiveCamera;

//import in.andente.livecamera.CameraView;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;

import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.Handler;
import android.preference.PreferenceManager;
//import android.view.KeyEvent;
import android.util.Log;
import android.view.MotionEvent;
import android.view.Window;
import android.view.WindowManager;
//import android.view.WindowManager;
import android.widget.Toast;
 
public class LiveCameraActivity extends Activity {
    /** Called when the activity is first created. */
    private CameraPreview mCameraPreview;
    private Boolean bool = true;

    /** Xbh` **/
    private Handler handler = new Handler();
    private Runnable runCamera;    // Jvr[N
    private Runnable runShutter;   // Vb^[^C}[ 
    //JԂԊui~bj
    private final int INIT_INTERVAL      =  1000;
    private final int SHUT_INI_INTERVAL  = 10000;
    private static int SHUT_RUN_INTERVAL = 60000;
    private static String infoUserid = "";
    
    //ݒ
    private static final int REQUEST_CODE_PREFERENCES = 1;

    @Override

    public void onCreate(Bundle savedInstanceState) {  
        super.onCreate(savedInstanceState);  
 
        // tXN[E^CgȂEfBXvCɖ邭
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN
                              | WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
        requestWindowFeature(Window.FEATURE_NO_TITLE);

        // ݒl̎擾
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
        SHUT_RUN_INTERVAL =  Integer.parseInt(pref.getString("infoCycle","0"));
        infoUserid = pref.getString("infoUserid", "");
        if ( infoUserid == "" ) {
            startActivityForResult(new Intent(this, Preference.class),REQUEST_CODE_PREFERENCES);
            
            infoUserid = doPostId("http://oup.imanan.com/och_ent.php" );
            pref.edit().putString("infoUserid", infoUserid).commit();
        }
        Log.d("infoUserid",pref.getString("infUserid", ""));

        // Jvr[
        mCameraPreview = new CameraPreview(this);

	     //JXbh`
        runCamera = new Runnable() {
          	 public void run() {
                 setContentView(mCameraPreview);
            }
        };
        
        //JXbhs
        handler.postDelayed(runCamera, INIT_INTERVAL);

	    //JVb^[Xbh`
        runShutter = new Runnable() {
            public void run() {
                if (mCameraPreview != null && bool) {  
                    //JVb^[Xbhs
                	bool = false; 
                    Toast.makeText(mCameraPreview.getContext(), "Be{摜Abv" , Toast.LENGTH_SHORT).show();  
                    mCameraPreview.takePicture();   // Be
                    bool = true; 
                }
                                
                //s\
                if ( SHUT_RUN_INTERVAL > 0 ) {
                  handler.postDelayed(this, SHUT_RUN_INTERVAL*60000);
                  Log.d("Tread","SHUT_RUN_INTERVAL:"+SHUT_RUN_INTERVAL+" min");
                }
            }
         };
        
	     //JVb^[Xbhsij
         if ( SHUT_RUN_INTERVAL > 0 ) {
        	 handler.postDelayed(runShutter, SHUT_INI_INTERVAL);
         }

    }

    /**
     *  L[
     */
    @Override
    public boolean onTouchEvent(MotionEvent event) {  
      if (event.getAction() == MotionEvent.ACTION_DOWN) {  
          if (mCameraPreview != null && bool) {  
          bool = false; 
          Toast.makeText(mCameraPreview.getContext(), "Be{摜Abv" , Toast.LENGTH_SHORT).show();  
          mCameraPreview.takePicture();   // Be
          bool = true; 
        }  
      }  
      return true;  
    }  

    // A
    @Override
    public void onResume() {
        super.onResume();
        // JA
        mCameraPreview.onResume();
        bool = true; 
    }
 
     // ޔ
    @Override
    public void onPause() {
        super.onPause();
        // Jޔ
        mCameraPreview.onPuse();
        bool = false; 
    }
    protected void onStop(){  
    	 super.onStop();  
         mCameraPreview.onPuse();
         bool = false; 
    }  
    	  
    public void onDestroy(){  
    	 super.onDestroy();  
         mCameraPreview.onPuse();
         bool = false; 
    }   
    
    public String doPostId( String url )
    {
      Log.d("doPostId","start");

      try {            
        DefaultHttpClient client = new DefaultHttpClient();
        //@͐œKPHPŏĂ
        HttpPost post = new HttpPost(url);
        MultipartEntity entity = new MultipartEntity();
        post.setEntity(entity);

        Log.d("doPostId","exec");

        //M
        HttpResponse response = client.execute( post );
        Log.d("doPostId","response");
        int status = response.getStatusLine().getStatusCode();
        if ( status != HttpStatus.SC_OK )
          throw new Exception( "" );
          Log.d("doPostId","end");
        return EntityUtils.toString( response.getEntity(), "UTF-8" ).replaceAll("\r\n", "\n").replaceAll("[\n|\r]", "");
      }
      catch ( Exception e ) {
        return null;
      }
    }
    public static String getInfoUserid()
    {
    	String[] infoUseridArr = infoUserid.split(".");
    	return(infoUseridArr[0]);
    }
    public static String getInfoServerid()
    {
    	String[] infoUseridArr = infoUserid.split(".");
    	return(infoUseridArr[1]);
    }
    
}
