package com.imanan.LiveCamera;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;

public class LiveMapActivity extends MapActivity {
	SharedPreferences pref;
    static final int INITIAL_ZOOM_LEVEL = 15;
    static int latitude = 35658610;
    static int longitude = 139745447;

	class MyItemizedOverlay extends ItemizedOverlay<OverlayItem> {

		public MyItemizedOverlay(Drawable defaultMarker) {
			super(defaultMarker);
			boundCenterBottom(defaultMarker);
			populate();
		}
		
		@Override
		protected OverlayItem createItem(int index) {
			getInfoGps();
			OverlayItem item = new OverlayItem(new GeoPoint(latitude, longitude), "Jʐ^", "Jʐ^");
//			OverlayItem item = new OverlayItem(new GeoPoint(35658610, 139745447), "^[", "^[");
			return item;
		}
		
		@Override
		public int size() {
			return 1;
		}
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    pref = PreferenceManager.getDefaultSharedPreferences(this);   
        final MapView mapView = new MapView(this, getResources().getString(R.string.map_key));
        
        mapView.setEnabled(true);
        mapView.setClickable(true);
        mapView.setBuiltInZoomControls(true);
        
		Drawable mark = getResources().getDrawable(R.drawable.marker);
		mark.setBounds(0, 0, mark.getMinimumWidth(), mark.getMinimumHeight()); // sȂƕ\Ȃ
		MyItemizedOverlay overlay = new MyItemizedOverlay(mark);
		mapView.getOverlays().add(overlay);
		
		getInfoGps();
        MapController controller = mapView.getController();
		GeoPoint point = new GeoPoint(latitude, longitude);
		controller.setCenter(point);
		controller.setZoom(INITIAL_ZOOM_LEVEL);
		
		setContentView(mapView);

/*        
        final MyLocationOverlay overlay = new MyLocationOverlay(getApplicationContext(), mapView);
        overlay.onProviderEnabled(LocationManager.GPS_PROVIDER); // GPS gp
        overlay.enableMyLocation();
        overlay.runOnFirstFix(new Runnable() {
            public void run() {
                mapView.getController().animateTo(
                    overlay.getMyLocation()); // ݈ʒuǔ
            }
        });
        mapView.getOverlays().add(overlay);
        mapView.invalidate();
        setContentView(mapView);
        */
	}
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	protected void getInfoGps() {
	    String infoGps = pref.getString("infoGps", "");
Log.d("onCreate",infoGps);
        String[] infoGpsArr = infoGps.split(",");  // latitude,longitude
        latitude  = (int)Math.round(Float.parseFloat(infoGpsArr[0])*1000000);
        longitude = (int)Math.round(Float.parseFloat(infoGpsArr[1])*1000000);
Log.d("onCreate","latitude:"+Integer.toString(latitude)+" longitude:"+Integer.toString(longitude));
	}
}
